<script lang="ts">
import Vue from 'vue';
import AnimatedNumber from './animated-number.vue';

export default Vue.extend({
  name: 'SurveyRoleBubble',
  components: {
    AnimatedNumber,
  },
  props: {
    percentage: {
      type: Number,
      required: true,
      default: 0,
    },
    color: {
      type: String,
      required: true,
      default: 'red',
    },
    dataAos: {
      type: String,
      default: 'fade-up',
      required: false,
    },
    dataAosDuration: {
      type: String,
      default: '600',
      required: false,
    },
    dataAosOffset: {
      type: String,
      default: '100',
      required: false,
    },
    textBubble: {
      type: String,
      default: undefined,
      required: false,
    },
  },
});
</script>

<template>
  <div>
    <div
      class="survey-stat-bubble"
      :class="`survey-stat-bubble--${color}`"
      :data-aos="dataAos"
      :data-aos-duration="dataAosDuration"
      :data-aos-offset="dataAosOffset"
    >
      <div :class="`survey-stat-bubble__circle`">
        <svg
          version="1.1"
          viewBox="0 0 500 500"
          preserveAspectRatio="xMinYMin meet"
        >
          <circle
            cx="250"
            cy="250"
            r="250"
            stroke-width="50"
            fill="transparent"
          />
        </svg>
      </div>
      <div
        :class="
          textBubble ? 'survey-stat-bubble__text' : 'survey-stat-bubble__number'
        "
      >
        <SlpTypography v-if="textBubble" variant="heading2-bold" tag="div">{{
          textBubble
        }}</SlpTypography>
        <SlpTypography v-else variant="heading2-bold" tag="div"
          ><AnimatedNumber :number="percentage"
        /></SlpTypography>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.survey-stat-bubble {
  position: relative;
  padding-bottom: 100%;

  &::before {
    content: '';
    position: absolute;
    width: 100%;
    height: 100%;
    border-radius: 100%;

    transition: all ease 1s 0.5s;
    left: 0;
    transform: scale(0);
    opacity: 0;
    @media (prefers-reduced-motion) {
      transform: scale(1);
      opacity: 1;
    }
  }
  &__circle {
    display: inline-block;
    position: absolute;
    width: 65%;
    padding-bottom: 65%;
    vertical-align: middle;
    top: 50%;
    left: 50%;
    transform: translate3d(-50%, -50%, 0);

    &:before {
      content: '';
      border: 2px solid transparent;
      position: absolute;
      width: 100%;
      height: 100%;
      border-radius: 100%;
      left: 0;
    }
    svg {
      display: inline-block;
      position: absolute;
      top: 0;
      left: 0;
    }
    circle {
      stroke: $color-primary-200;
      stroke-dasharray: 2000;
      stroke-dashoffset: 0;
      @media (prefers-reduced-motion) {
        stroke: transparent;
        stroke-dasharray: 0;
        stroke-dashoffset: 0;
      }
    }
  }
  &--red {
    &:before {
      background: radial-gradient(
        50% 50% at 50% 50%,
        rgba(226, 67, 41, 0.5) 0%,
        rgba(226, 67, 41, 0) 100%
      );
      filter: drop-shadow(0px 4px 4px rgba(0, 0, 0, 0.25));
    }
    .survey-stat-bubble__circle {
      &:before {
        background:
          linear-gradient($color-primary-200, $color-primary-200) padding-box,
          linear-gradient(to left, #f39fc5, #e24329) border-box;
      }
    }
  }
  &--purple {
    &:before {
      background: radial-gradient(
        50% 50% at 50% 50%,
        rgba(169, 137, 245, 0.5) 0%,
        rgba(169, 137, 245, 0) 100%
      );
      filter: drop-shadow(0px 4px 4px rgba(0, 0, 0, 0.25));
    }
    .survey-stat-bubble__circle {
      &:before {
        background:
          linear-gradient($color-primary-200, $color-primary-200) padding-box,
          linear-gradient(to right, #7759c2, #a989f5) border-box;
      }
    }
  }
  &--yellow {
    &:before {
      background: radial-gradient(
        50% 50% at 50% 50%,
        rgba(252, 161, 33, 0.5) 0%,
        rgba(252, 161, 33, 0) 100%
      );
      filter: drop-shadow(0px 4px 4px rgba(0, 0, 0, 0.25));
    }
    .survey-stat-bubble__circle {
      &:before {
        background:
          linear-gradient($color-primary-200, $color-primary-200) padding-box,
          linear-gradient(to right, #ffd58c, #fca121) border-box;
      }
    }
  }
  &--green {
    &:before {
      background: radial-gradient(
        50% 50% at 50% 50%,
        rgba(93, 218, 180, 0.5) 0%,
        rgba(93, 218, 180, 0) 100%
      );
      filter: drop-shadow(0px 4px 4px rgba(0, 0, 0, 0.25));
    }
    .survey-stat-bubble__circle {
      &:before {
        background:
          linear-gradient($color-primary-200, $color-primary-200) padding-box,
          linear-gradient(to right, #338f7e, #5ddab4) border-box;
      }
    }
  }
  &__number,
  &__text {
    position: absolute;
    top: 50%;
    font-family: 'GitLab Mono';
    transform: translate3d(-50%, -50%, 0);
    left: 50%;
    transition: all 0.3s ease;
    opacity: 0;
    text-align: center;
    @media (prefers-reduced-motion) {
      opacity: 1;
    }
  }
  &.aos-animate {
    circle {
      animation: dash 1s cubic-bezier(0.8, 0.47, 0.66, 0.83) forwards;
    }
    &::before {
      transform: scale(1);
      opacity: 1;
    }
    .survey-stat-bubble__number,
    .survey-stat-bubble__text {
      opacity: 1;
    }
  }
  @media (prefers-reduced-motion) {
    &.aos-animate {
      circle {
        animation: none;
      }
    }
  }
  @keyframes dash {
    to {
      stroke-dashoffset: 2000;
    }
  }
}
</style>
